"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var hasOwnProperty = Object.prototype.hasOwnProperty;

var cache = {};

var MemoryCache = (function () {
  function MemoryCache(name) {
    (0, _classCallCheck3.default)(this, MemoryCache);

    this.name = name;

    this.fetch.bind(this);
    this.clear.bind(this);

    cache[name] = cache[name] || {};
  }

  (0, _createClass3.default)(MemoryCache, [{
    key: "fetch",
    value: function fetch(key, miss) {
      if (hasOwnProperty.call(cache[this.name], key)) {
        return cache[this.name][key];
      }

      cache[this.name][key] = miss((0, _keys2.default)(cache[this.name]));
      return cache[this.name][key];
    }
  }, {
    key: "clear",
    value: function clear() {
      cache[this.name] = {};
    }
  }]);
  return MemoryCache;
})();

exports.default = MemoryCache;
